#version 410 
#extension GL_EXT_geometry_shader4 : enable

layout (lines, invocations = 1)       in;
layout (line_strip, max_vertices = 6) out;

uniform vec3 useXYZ;
uniform vec4 xColor, yColor, zColor;

out vec3 lineColor;

void main( void )
{
	if (useXYZ.x > 0.5)
	{
		lineColor = xColor.xyz;
		gl_Position = vec4( gl_PositionIn[0].xy, 0.0, 1.0 ); 
		EmitVertex();
		gl_Position = vec4( gl_PositionIn[1].xy, 0.0, 1.0 ); 
		EmitVertex();
		EndPrimitive();
	}	
	if (useXYZ.y > 0.5)
	{
		lineColor = yColor.xyz;
		gl_Position = vec4( gl_PositionIn[0].xz, 0.0, 1.0 ); 
		EmitVertex();
		gl_Position = vec4( gl_PositionIn[1].xz, 0.0, 1.0 ); 
		EmitVertex();
		EndPrimitive();
	}	
	if (useXYZ.z > 0.5)
	{
		lineColor = zColor.xyz;
		gl_Position = vec4( gl_PositionIn[0].xw, 0.0, 1.0 ); 
		EmitVertex();
		gl_Position = vec4( gl_PositionIn[1].xw, 0.0, 1.0 ); 
		EmitVertex();
		EndPrimitive();
	}	
}